library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;

entity Glitch_Detector_32Bit is
port(
   clock       : in  std_logic;
	reset       : in  std_logic;
	LA_Clock    : in  std_logic;
	pattern_in  : in  std_logic_vector(31 downto 0);
   glitch      : out std_logic_vector(31 downto 0));
end Glitch_Detector_32Bit;

architecture structure of Glitch_Detector_32Bit is
begin

Glitch_BIT_0 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(0),
   glitch      => glitch(0)); 
	
Glitch_BIT_1 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(1),
   glitch      => glitch(1)); 
	
Glitch_BIT_2 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(2),
   glitch      => glitch(2)); 
	
Glitch_BIT_3 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(3),
   glitch      => glitch(3)); 
	
Glitch_BIT_4 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(4),
   glitch      => glitch(4)); 
	
Glitch_BIT_5 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(5),
   glitch      => glitch(5)); 
	
Glitch_BIT_6 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(6),
   glitch      => glitch(6)); 
	
Glitch_BIT_7 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(7),
   glitch      => glitch(7)); 
	
Glitch_BIT_8 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(8),
   glitch      => glitch(8)); 
	
Glitch_BIT_9 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(9),
   glitch      => glitch(9)); 
	
Glitch_BIT_10 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(10),
   glitch      => glitch(10)); 
	
Glitch_BIT_11 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(11),
   glitch      => glitch(11)); 
	
Glitch_BIT_12 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(12),
   glitch      => glitch(12)); 
	
Glitch_BIT_13 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(13),
   glitch      => glitch(13)); 
	
Glitch_BIT_14 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(14),
   glitch      => glitch(14)); 
	
Glitch_BIT_15 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(15),
   glitch      => glitch(15)); 
	
Glitch_BIT_16 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(16),
   glitch      => glitch(16)); 
	
Glitch_BIT_17 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(17),
   glitch      => glitch(17)); 
	
Glitch_BIT_18 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(18),
   glitch      => glitch(18)); 
	
Glitch_BIT_19 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(19),
   glitch      => glitch(19)); 
	
Glitch_BIT_20 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(20),
   glitch      => glitch(20)); 
	
Glitch_BIT_21 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(21),
   glitch      => glitch(21)); 
	
Glitch_BIT_22 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(22),
   glitch      => glitch(22)); 
	
Glitch_BIT_23 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(23),
   glitch      => glitch(23)); 
	
Glitch_BIT_24 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(24),
   glitch      => glitch(24)); 
	
Glitch_BIT_25 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(25),
   glitch      => glitch(25)); 
	
Glitch_BIT_26 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(26),
   glitch      => glitch(26)); 
	
Glitch_BIT_27 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(27),
   glitch      => glitch(27)); 
	
Glitch_BIT_28 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(28),
   glitch      => glitch(28)); 
	
Glitch_BIT_29 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(29),
   glitch      => glitch(29)); 
	
Glitch_BIT_30 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(30),
   glitch      => glitch(30)); 
	
Glitch_BIT_31 : entity work.Glitch_Detector
port map(
   clock       => clock,
	reset       => reset,
	LA_Clock    => LA_Clock,
	pattern_in  => pattern_in(31),
   glitch      => glitch(31)); 
	
end structure;