-- Copyright (C) 2020  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and any partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details, at
-- https://fpgasoftware.intel.com/eula.

-- ***************************************************************************
-- This file contains a Vhdl test bench template that is freely editable to   
-- suit user's needs .Comments are provided in each section to help the user  
-- fill out necessary details.                                                
-- ***************************************************************************
-- Generated on "06/21/2024 13:23:18"
                                                            
-- Vhdl Test Bench template for design  :  user
-- 
-- Simulation tool : ModelSim-Altera (VHDL)
-- 

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                
library lpm;
use lpm.lpm_components.all;
library altera_mf;
use altera_mf.altera_mf_components.all;

ENTITY user_vhd_tst IS
END user_vhd_tst;
ARCHITECTURE user_arch OF user_vhd_tst IS
-- constants                                                 
-- signals                                                   
SIGNAL leds : STD_LOGIC_VECTOR(3 DOWNTO 0);
SIGNAL lsasBus : STD_LOGIC_VECTOR(31 DOWNTO 0);
SIGNAL mainClk : STD_LOGIC;
SIGNAL mcuI2cScl : STD_LOGIC;
SIGNAL mcuI2cSda : STD_LOGIC;
SIGNAL mcuUartRx : STD_LOGIC;
SIGNAL mcuUartTx : STD_LOGIC;
SIGNAL reset : STD_LOGIC;
SIGNAL slowClk : STD_LOGIC;
SIGNAL switches : STD_LOGIC_VECTOR(7 DOWNTO 0);


COMPONENT user
	port
	(
		-- Main clock inputs
		mainClk	: in std_logic;
		slowClk	: in std_logic;
		-- Main reset input
		reset		: in std_logic;
		-- MCU interface (UART, I2C)
		mcuUartTx	: in std_logic;
		mcuUartRx	: out std_logic;
		mcuI2cScl	: in std_logic;
		mcuI2cSda	: inout std_logic;
		-- Logic state analyzer/stimulator
		lsasBus	: inout std_logic_vector( 31 downto 0 );
		-- Dip switches
		switches	: in std_logic_vector( 7 downto 0 );
		-- LEDs
		leds		: out std_logic_vector( 3 downto 0 )
	);
END COMPONENT;
BEGIN

	i1 : user
	PORT MAP (
-- list connections between master ports and signals
   mainClk => mainClk,
   slowClk => slowClk,	
	reset => reset,
	mcuUartTx => mcuUartTx,
	mcuUartRx => mcuUartRx,
	mcuI2cScl => mcuI2cScl,
	mcuI2cSda => mcuI2cSda,
	lsasBus => lsasBus,
	switches => switches,
	leds => leds
	);
	
	clock_process : process
begin
mainClk <='0'; 
wait for 50 ns;
mainClk <= '1';
wait for 50 ns;
end process;

serial_clock_process : process
begin
lsasBus(13) <='0';
wait for 0.5 us;
lsasBus(13)<= '1';
wait for 0.5 us;
end process;

init : PROCESS                                               
-- variable declarations                                     
BEGIN                                                        
        -- code that executes only once
reset <= '0', '1' after 0.075 us; 	

--WRITE INSTRUCTION:CODE=01110111 ADDRESS=01110111(011101110111011101110111) DATA=01110111011101110111011101110111
	lsasBus(12)<= '0';                                                                
	lsasBus(15)<= '0'; 
	wait for 2.075 us;                                                --3ns
	lsasBus(15)<= '1';
	wait for 1 us;                                                --4ns                                               --7ns
	lsasBus(15)<= '0';
	wait for 5 us;                                                --8ns
	
	lsasBus(15)<= '1';
   wait for 3 us;                                                --11ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --12ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --15ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --16ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --19ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --20ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --23ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --24ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --27ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --28ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --31ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --32ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --35ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --36ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --39ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --40ns
	
	lsasBus(15)<= '1';
   wait for 3 us;                                                --43ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --44ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --47ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --48ns
	lsasBus(15)<= '1';
   wait for 3 us;                                                --51ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --52ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --55ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --56ns
	lsasBus(15)<= '1';
   wait for 3 us;                                                --59ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --60ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --63ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --64ns
	lsasBus(15)<= '1';
   wait for 3 us;                                                --67ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --68ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --71ns
	lsasBus(15)<= '0';
 	wait for 2 us;                                                --72ns
---------------------------------------------------------------------------------------
--WRITE INSTRUCTION:CODE=01110111 ADDRESS=01111011(011101000111011101110011) DATA=11101110111011011000110110111110
 
	lsasBus(15)<= '0'; 
	wait for 2 us;                                                --3ns
	lsasBus(15)<= '1';
	wait for 1 us;                                                --4ns                                               --7ns
	lsasBus(15)<= '0';
	wait for 5 us;                      
	
	lsasBus(15)<= '1';
   	wait for 2 us;                                                --11ns
	lsasBus(15)<= '0';
	wait for 2 us;                                                --12ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --15ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --16ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --19ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --20ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --23ns
	lsasBus(15)<= '0';
	wait for 3 us;                                                --24ns
	lsasBus(15)<= '1';
	wait for 1 us;                                                --27ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --28ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --31ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --32ns
	lsasBus(15)<= '1';                                                       
	wait for 2 us;                                                --35ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --36ns
	lsasBus(15)<= '1';
	wait for 4 us;                                                --39ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --40ns
	
	lsasBus(15)<= '1';
   wait for 3 us;                                                --43ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --44ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --47ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --48ns
	lsasBus(15)<= '1';
   wait for 3 us;                                                --51ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --52ns
	lsasBus(15)<= '1';
	wait for 2 us;                                                --55ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --56ns
	lsasBus(15)<= '1';
   wait for 2 us;                                                --59ns
	lsasBus(15)<= '0';
	wait for 3 us;                                                --60ns
	lsasBus(15)<= '1';
	wait for 2 us;                                                --63ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --64ns
	lsasBus(15)<= '1';
	wait for 2 us;                                                --67ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --68ns
	lsasBus(15)<= '1';
	wait for 5 us;                                                --71ns
	lsasBus(15)<= '0';
	wait for 2 us; 	                                            --72ns
		
------------------------------------------------------------------------
	--READ INSTRUCTION
 
	lsasBus(15)<= '0';
	wait for 2 us; 
	lsasBus(15)<= '1'; 
	wait for 1 us;                                                --3ns
	lsasBus(15)<= '0';
	wait for 4 us;                                                --4ns                                               --7ns
	lsasBus(15)<= '1';
	wait for 1 us;  
	
	lsasBus(15)<= '1';
   wait for 3 us;                                                --11ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --12ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --15ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --16ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --19ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --20ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --23ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --24ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --27ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --28ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --31ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --32ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --35ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --36ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --39ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --40ns  
	lsasBus(15)<= '1';
	wait for 33 us;                                               --72ns
	
--------------------------------------------------------------------------------------------------------------	
	lsasBus(15)<= '0';
	wait for 2 us; 
	lsasBus(15)<= '1'; 
	wait for 1 us;                                                --3ns
	lsasBus(15)<= '0';
	wait for 4 us;                                                --4ns                                               --7ns
	lsasBus(15)<= '1';
	wait for 1 us;    
	
	lsasBus(15)<= '1';
   wait for 2 us;                                                --11ns
	lsasBus(15)<= '0';
	wait for 2 us;                                                --12ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --15ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --16ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --19ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --20ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --23ns
	lsasBus(15)<= '0';
	wait for 3 us;                                                --24ns
	lsasBus(15)<= '1';
	wait for 1 us;                                                --27ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --28ns
	lsasBus(15)<= '1';
	wait for 3 us;                                                --31ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --32ns
	lsasBus(15)<= '1';                                                       
	wait for 2 us;                                                --35ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --36ns
	lsasBus(15)<= '1';
	wait for 4 us;                                                --39ns
	lsasBus(15)<= '0';
	wait for 1 us;                                                --40ns
	lsasBus(15)<= '1';
   wait for 31 us;  
	  
WAIT;                                                       
END PROCESS init;                                           
always : PROCESS                                              
-- optional sensitivity list                                  
-- (        )                                                 
-- variable declarations                                      
BEGIN                                                         
        -- code executes for every event on sensitivity list  
WAIT;                                                        
END PROCESS always;                                          
END user_arch;


